/*
 * Copyright 2011 Endea
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package endea.internal.auth

import endea._
import endea.auth._
import endea.http._
import endea.html._

object LoginControl extends Control {

  val name = "Login"

  private val openid_uri = Controller.encode(OpenIdAction)
  private val signin_uri = Controller.encode(SignInAction)

  override def icon = Icon(LoginControl, "login.png")

  override def contribute(event: Event[_]) = event.user.isEmpty

  override def url(event: Event[_]) = {

    if (AuthConfig.openId)
      openid_uri
    else
      signin_uri
  }
}
